import 'package:yona/yona.dart';
import 'dart:io';

void main() async {
  const n = 5;
  List<Node> nodes = [];
  for (var i = 0; i < n; i++) {
    var node = Node(
        await Crypto.genSK(),
        await Tail.connect(NetAddr.fromString("yonafediverse.com:7777")),
        File("/tmp/" + DateTime.now().microsecondsSinceEpoch.toString()));
    if (i > 0) {
      var pre = nodes[i - 1];
      node.stream.forEach((packet) async {
        await node.send(Crypto.derivePK(pre.sk), packet.data);
      });
    } else {
      node.stream.timeout(Duration(seconds: n * 2)).forEach((packet) {
        print((DateTime.now().microsecondsSinceEpoch -
                Utils.parseBinaryToInt(packet.data)) /
            1e+6);
        for (var node in nodes) {
          node.close();
        }
      });
    }
    await node.publish(i.toString());
    nodes.add(node);
  }
  await nodes.first.send(Crypto.derivePK(nodes.last.sk),
      Utils.int64ToBinary(DateTime.now().microsecondsSinceEpoch));
}
