import 'dart:async';

import 'package:yona/yona.dart';

void main() async {
  var node1 = await Node.create(
      await Crypto.genSK(), NetAddr.fromString("yonafediverse.com:7777"));
  await node1.publish("node1");
  var node2 = Node(await Crypto.genSK(),
      await Tail.connect(NetAddr.fromString("yonafediverse.com:7777")));
  await node2.publish("node2");
  node1.stream.forEach((packet) {
    print(packet.id);
  });
  node2.stream.forEach((packet) {
    print(packet.id);
  });
  Timer.periodic(Duration(milliseconds: 1000), (timer) async {
    try {
      await node1.send(
          Crypto.derivePK(node2.sk), await Crypto.randBytes(200), timer.tick);
      await node2.send(
          Crypto.derivePK(node1.sk), await Crypto.randBytes(200), timer.tick);
    } catch (error) {
      print(error);
    }
  });
}
